<?xml version="1.0" encoding="UTF-8"?>
<stylesheet
	xmlns="http://www.w3.org/1999/XSL/Transform"
	xmlns:xs="http://www.w3.org/2001/XMLSchema"
	xmlns:uct="http://uctool.sf.net/"
	version="2.0">

	<template match="@*|node()|text()" mode="copy">
	<!-- Copy template -->
		<copy>
			<apply-templates select="@*|node()|text()" mode="copy" />
		</copy>
	</template>

	<function name="uct:page-start" as="xs:string">
		<param name="page-title" as="xs:string" />
		<variable name="result">
<text/>&lt;!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
&lt;html>
&lt;head>
&lt;title><value-of select="$page-title"/>&lt;/title>
&lt;meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
&lt;link rel="stylesheet" type="text/css" href="../resources/ucs.css"/>
&lt;link rel="shortcut icon" href="../resources/favicon.ico" />
&lt;/head>
&lt;body>
&lt;div>&lt;a href="index.html">#section#&lt;/a> &lt;a href="../index.html">#home#&lt;/a>&lt;/div><text />
		</variable>
		<value-of select="$result" />
	</function>

	<function name="uct:page-end" as="xs:string">
		<variable name="result">
&lt;p/>&lt;div>&lt;a href="index.html">#section#&lt;/a> &lt;a <text />
	<text />href="../index.html">#home#&lt;/a>&lt;/div><text />
	<value-of select="uct:uctool-link()" />
&lt;/body>
&lt;/html>
<text />
		</variable>
		<value-of select="$result" />
	</function>

	<function name="uct:uctool-link" as="xs:string">
		<variable name="result">
&lt;div class="uctlink">#created.in# &lt;a <text />
	<text />href="http://uctool.sf.net">uctool.sf.net&lt;/a>.&lt;/div><text />
		</variable>
		<value-of select="$result" />
	</function>

	<function name="uct:cell" as="xs:string">
		<param name="value" as="xs:string*" />
		<choose>
			<when test="$value">
				<value-of select="$value" />
			</when>
			<otherwise>&amp;nbsp;</otherwise>
		</choose>
	</function>

	<function name="uct:indent" as="xs:string">
		<value-of select="'&amp;nbsp;&amp;nbsp;&amp;nbsp;&amp;nbsp;'" />
	</function>

	<function name="uct:step-ref" as="xs:string">
		<param name="this" as="node()" />
		<param name="handle" as="xs:string*" />
		<choose>
			<when test="$this/ancestor::uct:use-case/uct:success/*[@handle=$handle]">
				<value-of select="count($this/ancestor::uct:use-case/
					uct:success/*[@handle=$handle]/preceding-sibling::*)+1" />
			</when>
			<otherwise>?</otherwise>
		</choose>
	</function>

	<function name="uct:actor-ref" as="xs:string">
		<param name="code" as="xs:string" />
		<param name="merged-file" as="node()" />
		<param name="link-type" as="xs:string*" />
		<variable name="name" select="uct:actor-name-ref($code,$merged-file)" />
		<value-of select="uct:ref-base(
			'actor',$code,$name,$name,$link-type,'multi')" />
	</function>

	<function name="uct:actor-name-ref" as="xs:string">
		<param name="code" as="xs:string" />
		<param name="merged-file" as="node()" />
		<call-template name="verify-count-1-template">
			<with-param name="name" select="'actor'" />
			<with-param name="code" select="$code" />
			<with-param name="items" select="$merged-file//uct:actor[@code=$code]" />
		</call-template>
		<value-of select="$merged-file//uct:actor[@code=$code]/@name" />
	</function>

	<function name="uct:uc-ref-base" as="xs:string">
		<param name="code" as="xs:string" />
		<param name="goal" as="xs:string" />
		<param name="text" as="xs:string" />
		<param name="link-type" as="xs:string*" />
		<param name="label-type" as="xs:string*" />
		<variable name="name" select="concat($code,' - ',$goal)" />
		<value-of select="uct:ref-base('uc',$code,$name,$text,$link-type,$label-type)" />
	</function>

	<function name="uct:uc-ref" as="xs:string">
		<param name="code" as="xs:string" />
		<param name="text" as="xs:string" />
		<param name="merged-file" as="node()" />
		<param name="link-type" as="xs:string*" />
		<param name="label-type" as="xs:string*" />
		<call-template name="verify-count-1-template">
			<with-param name="name" select="'use case'" />
			<with-param name="code" select="$code" />
			<with-param name="items" select="$merged-file//uct:use-case[@code=$code]" />
		</call-template>
		<variable name="goal" select="$merged-file//uct:use-case[@code=$code]/@goal" />
		<value-of select="uct:uc-ref-base($code,$goal,$text,$link-type,$label-type)" />
	</function>

	<function name="uct:goal-ref" as="xs:string">
		<param name="use-case" as="node()" />
		<param name="uc-ref-type" as="xs:string*" />
		<variable name="code" select="$use-case/@code" />
		<variable name="goal" select="$use-case/@goal" />
		<choose>
		<when test="$code">
			<value-of select="uct:uc-ref-base($code,$goal,'',$uc-ref-type,'multi')"/>
		</when>
		<otherwise>
			<value-of select="$goal" />
		</otherwise>
		</choose>
	</function>

	<function name="uct:visibility" as="xs:string">
		<param name="code" as="xs:string*" />
		<choose>
			<when test="$code='black'">#visibility.black#</when>
			<when test="$code='white'">#visibility.white#</when>
			<otherwise>?</otherwise>
		</choose>
	</function>

	<function name="uct:level" as="xs:string">
		<param name="code" as="xs:string*" />
		<choose>
			<when test="$code='sea'">#level.sea#</when>
			<when test="$code='kite'">#level.kite#</when>
			<when test="$code='cloud'">#level.cloud#</when>
			<when test="$code='fish'">#level.fish#</when>
			<when test="$code='clam'">#level.clam#</when>
			<otherwise>?</otherwise>
		</choose>
	</function>

	<function name="uct:uc-type" as="xs:string">
		<param name="type" as="xs:string*" />
		<choose>
			<when test="$type='system'">#uc.type.system#</when>
			<when test="$type='organization'">#uc.type.organization#</when>
			<otherwise>?</otherwise>
		</choose>
	</function>

	<function name="uct:uc-references" as="xs:string">
		<param name="merged" as="node()*" />
		<param name="uc-code" as="xs:string*" />
		<param name="link-type" as="xs:string*" />
		<variable name="result">
			<if test="$merged//uct:uc-group//uct:uc-ref[@code=$uc-code]">
				<text>
&lt;tr>&lt;td>&lt;span class="label">#uc.references#:&lt;/span></text>
				<value-of select="uct:list-uc-references(distinct-values(
					$merged//uct:uc-group//uct:uc-ref[@code=$uc-code]/
					ancestor::uct:use-case/@code),$merged,$link-type)" />
				<text>
&lt;/td>&lt;/tr></text>
			</if>
		</variable>
		<value-of select="$result"/>
	</function>

	<function name="uct:data-references-uc" as="xs:string">
		<param name="merged" as="node()*" />
		<param name="data-code" as="xs:string*" />
		<param name="link-type" as="xs:string*" />
		<variable name="result">
			<if test="$merged//uct:uc-group//uct:data-ref[@code=$data-code]">
				<text>
&lt;div>&lt;span class="label">#data.references.uc#:&lt;/span></text>
				<value-of select="uct:list-uc-references(distinct-values(
					$merged//uct:uc-group//uct:data-ref[@code=$data-code]/
					ancestor::uct:use-case/@code),$merged,$link-type)" />
				<text>
&lt;/div></text>
			</if>
		</variable>
		<value-of select="$result"/>
	</function>

	<function name="uct:list-uc-references" as="xs:string">
		<param name="uc-codes" as="xs:string*" />
		<param name="merged" as="node()*" />
		<param name="link-type" as="xs:string*" />
		<variable name="result">
			<for-each select="$uc-codes">
				<variable name="refed-code" select="." />
				<variable name="refed-uc" select="$merged//uct:use-case[@code=$refed-code]"/>
				<text>
</text>
				<value-of select="uct:uc-ref($refed-code,'',$merged,$link-type,'multi')"/>
				<if test="not(position()=last())">
					<text>,</text>
				</if>
			</for-each>
		</variable>
		<value-of select="$result"/>
	</function>

	<function name="uct:data-references-data" as="xs:string">
		<param name="merged" as="node()*" />
		<param name="data-code" as="xs:string*" />
		<param name="link-type" as="xs:string*" />
		<variable name="result">
			<if test="$merged//uct:data-structure[uct:attribute/@type=$data-code 
				or uct:description/uct:data-ref/@code=$data-code]">
				<text>
&lt;div>&lt;span class="label">#data.references.data#:&lt;/span></text>
				<for-each select="distinct-values(
					($merged//uct:data-structure/uct:attribute[@type=$data-code]/
						ancestor::uct:data-structure/@code,
					$merged//uct:data-structure/uct:description/uct:data-ref[@code=$data-code]/
						ancestor::uct:data-structure/@code))">
					<variable name="refed-code" select="." />
					<variable name="refed-data" select="$merged//uct:data-structure[@code=$refed-code]"/>
					<text>
</text>
					<value-of select="uct:data-ref($refed-code,'',$merged,$link-type)"/>
					<if test="not(position()=last())">
						<text>,</text>
					</if>
				</for-each>
				<text>
&lt;/div></text>
			</if>
		</variable>
		<value-of select="$result"/>
	</function>

	<function name="uct:status" as="xs:string*">
		<param name="status" as="xs:string*" />
		<choose>
			<when test="$status='display-only'">#status.display-only#</when>
			<when test="$status='optional'">#status.optional#</when>
			<when test="$status='mandatory'">#status.mandatory#</when>
			<when test="$status='unique'">#status.unique#</when>
			<when test="$status='natural-key'">#status.natural.key#</when>
			<when test="$status='primary-key'">#status.primary.key#</when>
		</choose>
	</function>

	<function name="uct:status-hint" as="xs:string*">
		<param name="status" as="xs:string*" />
		<choose>
			<when test="$status='display-only'"> title="#status.hint.display-only#"</when>
			<when test="$status='optional'"> title="#status.hint.optional#"</when>
			<when test="$status='mandatory'"> title="#status.hint.mandatory#"</when>
			<when test="$status='unique'"> title="#status.hint.unique#"</when>
			<when test="$status='natural-key'"> title="#status.hint.natural.key#"</when>
			<when test="$status='primary-key'"> title="#status.hint.primary.key#"</when>
		</choose>
	</function>

	<function name="uct:data-type" as="xs:string*">
		<param name="type" as="xs:string*" />
		<param name="length" as="xs:string*" />
		<param name="collection" as="xs:string*" />
		<param name="merged-file" as="node()" />
		<param name="link-type" as="xs:string*" />
		<variable name="result">
			<if test="$collection='true'">#data.collection# [</if>
			<choose>
			<when test="$type='integer'">#data.type.integer#</when>
			<when test="$type='float'">#data.type.float#</when>
			<when test="$type='decimal'">#data.type.decimal#</when>
			<when test="$type='boolean'">#data.type.boolean#</when>
			<when test="$type='date'">#data.type.date#</when>
			<when test="$type='time'">#data.type.time#</when>
			<when test="$type='date-time'">#data.type.date.time#</when>
			<when test="$type='timestamp'">#data.type.timestamp#</when>
			<when test="$type='string'">#data.type.string#</when>
			<when test="$type='binary'">#data.type.binary#</when>
			<when test="not(empty($type))">
				<value-of select="uct:data-ref($type,'',$merged-file,$link-type)" />
			</when>
			</choose>
			<if test="$collection='true'">]</if>
			<if test="not(empty($length)) or $type='string' or $type='binary'">
				<value-of select="concat(' [',$length,']')"/>
			</if>
		</variable>
		<value-of select="$result" />
	</function>

	<function name="uct:inherited-actor-codes" as="xs:string*">
		<param name="actor-code" as="xs:string" />
		<param name="merged-file" as="node()" />
		<variable name="extended-actor-codes" 
			select="$merged-file//uct:actor[$actor-code=@code]/uct:extends-actor/@code" />
		<variable name="inherited-actor-codes" 
			select="uct:inherited-actor-codes-internal($extended-actor-codes,$merged-file)" />
		<copy-of select="$inherited-actor-codes" />
	</function>

	<function name="uct:inherited-actor-codes-internal" as="xs:string*">
		<param name="actor-codes" as="xs:string*" />
		<param name="merged-file" as="node()" />
		<variable name="extended-actor-codes" 
			select="$merged-file//uct:actor[not(empty(index-of($actor-codes,@code)))]
					/uct:extends-actor/@code" />
		<copy-of select="($actor-codes,$extended-actor-codes)" />
	</function>

	<function name="uct:data-ref" as="xs:string">
		<param name="code" as="xs:string" />
		<param name="text" as="xs:string" />
		<param name="merged-file" as="node()" />
		<param name="link-type" as="xs:string*" />
		<call-template name="verify-count-1-template">
			<with-param name="name" select="'data structure'" />
			<with-param name="code" select="$code" />
			<with-param name="items" select="$merged-file//uct:data-structure[@code=$code]" />
		</call-template>
		<variable name="name" select="$merged-file//uct:data-structure[@code=$code]/@name" />
		<value-of select="uct:ref-base('data',$code,$name,$text,$link-type,$link-type)" />
	</function>

	<function name="uct:ref-base" as="xs:string">
		<param name="type" as="xs:string" />
		<param name="code" as="xs:string" />
		<param name="name" as="xs:string" />
		<param name="text" as="xs:string" />
		<param name="link-type" as="xs:string*" />
		<param name="label-type" as="xs:string*" />
		<variable name="result">
			<text>&lt;a href="</text>
			<choose>
				<when test="$link-type='single'">
					<text />#<value-of select="$type" />_<value-of select="$code" />
				</when>
				<otherwise>
					<text />../<value-of select="$type" />/<text />
					<value-of select="$code" />.html<text />
				</otherwise>
			</choose>
			<text>" title="</text>
			<value-of select="$name" />
			<text>"></text>
			<choose>
			<when test="$text=''"><value-of select="$name" /></when>
			<otherwise><value-of select="$text" /></otherwise>
			</choose>
			<if test="$label-type='single' and $text!='' and $text!=$name">
				<text /> (<value-of select="$name" />)<text />
			</if>
			<text>&lt;/a></text>
		</variable>
		<value-of select="$result" />
	</function>

	<template name="verify-count-1-template">
		<param name="name" />
		<param name="code" />
		<param name="items" />
		<if test="count($items)!=1">
			<message>
				<text />Error processing <value-of select="$name" />
				<text /> with code <value-of select="$code" />
			</message>
			<message terminate="yes">
				<text />Exactly 1 <value-of select="$name" />
				<text /> with the code expected, but found <value-of select="count($items)" />
			</message>
		</if>
	</template>

	<function name="uct:img" as="xs:string">
		<param name="name" as="xs:string" />
		<param name="alt" as="xs:string" />
		<variable name="result">
			<text/>&lt;img src="../resources/<text/>
			<value-of select="$name"/>.gif" alt="<text/>
			<value-of select="$alt"/>" title="<text/>
			<value-of select="$alt"/>"/><text/>
		</variable>
		<value-of select="$result" />
	</function>

</stylesheet>
